searchNodes=[{"doc":"A small library that provides Elixir modules with subscribe/publish functionality. Separate core business logic from external concerns Publish events synchronously or asynchronously Usage Create your router, usually one per app but can be many. You'll define all the subscriptions in there. It's simply a GenServer that will keep track of subscriptions and allow you to add or remove more. (Don't forget to add it to your supervision tree) Router defmodule MyApp.Events do use Shout.Router subscribe ( MyApp.Users.Create , :user_created , to : &amp; MyApp.Emails . welcome_email / 1 ) # Runs it asynchronously (uses Kernel.spawn/1) subscribe ( MyApp.Users.Updated , :user_updated , to : &amp; MyApp.Service . custom_task / 1 , asnyc : true ) end A subscription can be added at runtime too: MyApp.Events . subscribe ( MyApp.SomeTask , :success , &amp; MyApp.Notify . send_email / 1 ) Shout will make sure there are no duplicate subscriptions. Publishing By default when publishing an event using broadcast the subscriptions will be executed synchronously. defmodule MyApp.Users.Create do use MyApp.Events.Publisher def create ( params ) do user = User . create ( params ) broadcast ( :user_created , user ) # Will trigger: MyApp.Emails.welcome_email/1 end end","ref":"Shout.html","title":"Shout","type":"module"},{"doc":"Use this module to setup your subscription module. Add it to your supervision tree, it'll start a simple GenServer and store the subscriptions. defmodule MyApp.Events do use Shout.Router subscribe ( MyApp.Users.Create , :user_created , to : &amp; MyApp.Emails . welcome_email / 1 ) end defmodule MyApp.Service.User do use MyApp.Events.Publisher def create ( ... ) do broadcast ( :user_created , %{ email : &quot;jon@snow.com&quot; } ) end end defmodule MyApp.Emails do def welcome_email ( %{ email : email } ) do SendEmail . to ( email ) end end","ref":"Shout.Router.html","title":"Shout.Router","type":"module"},{"doc":"","ref":"Shout.Router.html#subscribe/3","title":"Shout.Router.subscribe/3","type":"macro"},{"doc":"","ref":"Shout.Router.html#unsubscribe/2","title":"Shout.Router.unsubscribe/2","type":"macro"},{"doc":"Contains the logic on how subscriptions are executed","ref":"Shout.Runner.html","title":"Shout.Runner","type":"module"},{"doc":"","ref":"Shout.Runner.html#run/2","title":"Shout.Runner.run/2","type":"function"},{"doc":"GenServer to persist the subscriptions. They are stored as an array [ % Shout.Subscription { from : MyService , event : :created , to : &amp; Email . notify / 1 } , ... ]","ref":"Shout.Store.html","title":"Shout.Store","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Shout.Store.html#child_spec/1","title":"Shout.Store.child_spec/1","type":"function"},{"doc":"","ref":"Shout.Store.html#register_subscription/2","title":"Shout.Store.register_subscription/2","type":"function"},{"doc":"","ref":"Shout.Store.html#start_link/1","title":"Shout.Store.start_link/1","type":"function"},{"doc":"","ref":"Shout.Store.html#subscriptions/1","title":"Shout.Store.subscriptions/1","type":"function"},{"doc":"","ref":"Shout.Store.html#subscriptions/3","title":"Shout.Store.subscriptions/3","type":"function"},{"doc":"","ref":"Shout.Store.html#unregister_subscription/2","title":"Shout.Store.unregister_subscription/2","type":"function"},{"doc":"A struct to represent a subscription.","ref":"Shout.Subscription.html","title":"Shout.Subscription","type":"module"},{"doc":"","ref":"Shout.Subscription.html#t:t/0","title":"Shout.Subscription.t/0","type":"type"},{"doc":"A small library that provides Elixir modules with subscribe/publish functionality. Separate core business logic from external concerns Publish events synchronously or asynchronously # Usage Create your router, usually one per app but can be many. You'll define all the subscriptions in there. It's simply a GenServer that will keep track of subscriptions and allow you to add or remove more. (Don't forget to add it to your supervision tree) ### Router defmodule MyApp.Events do use Shout.Router subscribe ( MyApp.Users.Create , :user_created , to : &amp; MyApp.Emails . welcome_email / 1 ) # Runs it asynchronously (uses Kernel.spawn/1) subscribe ( MyApp.Users.Updated , :user_updated , to : &amp; MyApp.Service . custom_task / 1 , asnyc : true ) end A subscription can be added at runtime too: MyApp.Events . subscribe ( MyApp.SomeTask , :success , &amp; MyApp.Notify . send_email / 1 ) Shout will make sure there are no duplicate subscriptions. ### Publishing By default when publishing an event using broadcast the subscriptions will be executed synchronously. defmodule MyApp.Users.Create do use MyApp.Events.Publisher def create ( params ) do user = User . create ( params ) broadcast ( :user_created , user ) # Will trigger: MyApp.Emails.welcome_email/1 end end","ref":"readme.html","title":"Shout","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding shout to your list of dependencies in mix.exs : def deps do [ { :shout , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/shout .","ref":"readme.html#installation","title":"Shout - Installation","type":"extras"}]